Sign in Start for free

Deployment Freeze

Get DeploymentFreezes

GET /api/deploymentfreezes

Gets a paginated set of DeploymentFreezes.

Query Parameters

  • effectiveDate string
    URL encoded timestamp to search recurring deployment freezes at a given point in time. Format date-time.
  • environmentIds array of string
    List of Environment IDs which if specified, filters the result to only include DeploymentFreeze with matching Environment IDs.
  • ids array of string
    List of DeploymentFreeze IDs which if specified, filters the result to only include DeploymentFreeze with matching IDs.
  • includeComplete boolean
    Set to false to only return active Deployment Freezes.
  • partialName string
    A partial or complete name to search on. This will perform a “contains” style match against the supplied name or name-fragment.
  • projectIds array of string
    List of Project IDs which if specified, filters the result to only include DeploymentFreeze with matching Project IDs.
  • skip integer (required)
    Number of items to skip. Defaults to zero. Minimum 0.
  • status string
  • take integer (required)
    Number of items to take. Defaults to 30. Minimum 0.
  • tenantIds array of string
    List of Tenant IDs which if specified, filters the result to only include DeploymentFreeze with matching Tenant IDs.

Response

200 — Requested list of DeploymentFreezes

  • Count integer
  • DeploymentFreezes array of object
    • Description string
    • End string
      Format date-time.
    • Id string
    • Name string
      Minimum length 1.
    • ProjectEnvironmentScope object
    • RecurringSchedule object
    • Start string
      Format date-time.
    • TenantProjectEnvironmentScope array of object

Example Response

JSON
{
  "Count": 0,
  "DeploymentFreezes": [
    {
      "Description": "string",
      "End": "2020-01-01T00:00:00.000Z",
      "Id": "string",
      "Name": "string",
      "ProjectEnvironmentScope": {
        "additionalProp1": [
          "string"
        ],
        "additionalProp2": [
          "string"
        ],
        "additionalProp3": [
          "string"
        ]
      },
      "RecurringSchedule": {
        "EndAfterOccurrences": 0,
        "EndDate": "2020-01-01T00:00:00.000Z",
        "EndOnDate": "2020-01-01T00:00:00.000Z",
        "EndType": "Never",
        "StartDate": "2020-01-01T00:00:00.000Z",
        "Type": "Daily",
        "Unit": 0,
        "UserUtcOffsetInMinutes": 0
      },
      "Start": "2020-01-01T00:00:00.000Z",
      "TenantProjectEnvironmentScope": [
        {}
      ]
    }
  ]
}

Create a new deployment freeze

POST /api/deploymentfreezes

Request Body

  • Description string
  • End string (required)
    Format date-time.
  • Name string (required)
    Minimum length 1. Maximum length 200.
  • ProjectEnvironmentScope object
  • Start string (required)
    Format date-time.

Response

201 — Created

  • Description string
  • End string
    Format date-time.
  • Id string
  • Name string
    Minimum length 1.
  • ProjectEnvironmentScope object
  • RecurringSchedule object
    • EndAfterOccurrences integer
    • EndDate string
      Format date-time.
    • EndOnDate string
      Format date-time.
    • EndType enum
      Allowed values: Never, OnDate, AfterOccurrences.
    • StartDate string
      Format date-time.
    • Type enum
      Allowed values: Daily, Weekly, Monthly, Annually.
    • Unit integer
    • UserUtcOffsetInMinutes integer
  • Start string
    Format date-time.
  • TenantProjectEnvironmentScope array of object
    • EnvironmentId string
    • ProjectId string
    • TenantId string

Example Request

JSON
{
  "Description": "string",
  "End": "2020-01-01T00:00:00.000Z",
  "Name": "string",
  "ProjectEnvironmentScope": {
    "additionalProp1": [
      "string"
    ],
    "additionalProp2": [
      "string"
    ],
    "additionalProp3": [
      "string"
    ]
  },
  "Start": "2020-01-01T00:00:00.000Z"
}

Example Response

JSON
{
  "Description": "string",
  "End": "2020-01-01T00:00:00.000Z",
  "Id": "string",
  "Name": "string",
  "ProjectEnvironmentScope": {
    "additionalProp1": [
      "string"
    ],
    "additionalProp2": [
      "string"
    ],
    "additionalProp3": [
      "string"
    ]
  },
  "RecurringSchedule": {
    "EndAfterOccurrences": 0,
    "EndDate": "2020-01-01T00:00:00.000Z",
    "EndOnDate": "2020-01-01T00:00:00.000Z",
    "EndType": "Never",
    "StartDate": "2020-01-01T00:00:00.000Z",
    "Type": "Daily",
    "Unit": 0,
    "UserUtcOffsetInMinutes": 0
  },
  "Start": "2020-01-01T00:00:00.000Z",
  "TenantProjectEnvironmentScope": [
    {
      "EnvironmentId": "string",
      "ProjectId": "string",
      "TenantId": "string"
    }
  ]
}

Get a deployment freeze by ID

GET /api/deploymentfreezes/{id}

Path Parameters

  • id string (required)
    Id of the deployment freeze.

Response

200 — The requested deployment freeze

  • Description string
  • End string
    Format date-time.
  • Id string
  • Name string
    Minimum length 1.
  • ProjectEnvironmentScope object
  • RecurringSchedule object
    • EndAfterOccurrences integer
    • EndDate string
      Format date-time.
    • EndOnDate string
      Format date-time.
    • EndType enum
      Allowed values: Never, OnDate, AfterOccurrences.
    • StartDate string
      Format date-time.
    • Type enum
      Allowed values: Daily, Weekly, Monthly, Annually.
    • Unit integer
    • UserUtcOffsetInMinutes integer
  • Start string
    Format date-time.
  • TenantProjectEnvironmentScope array of object
    • EnvironmentId string
    • ProjectId string
    • TenantId string

Example Response

JSON
{
  "Description": "string",
  "End": "2020-01-01T00:00:00.000Z",
  "Id": "string",
  "Name": "string",
  "ProjectEnvironmentScope": {
    "additionalProp1": [
      "string"
    ],
    "additionalProp2": [
      "string"
    ],
    "additionalProp3": [
      "string"
    ]
  },
  "RecurringSchedule": {
    "EndAfterOccurrences": 0,
    "EndDate": "2020-01-01T00:00:00.000Z",
    "EndOnDate": "2020-01-01T00:00:00.000Z",
    "EndType": "Never",
    "StartDate": "2020-01-01T00:00:00.000Z",
    "Type": "Daily",
    "Unit": 0,
    "UserUtcOffsetInMinutes": 0
  },
  "Start": "2020-01-01T00:00:00.000Z",
  "TenantProjectEnvironmentScope": [
    {
      "EnvironmentId": "string",
      "ProjectId": "string",
      "TenantId": "string"
    }
  ]
}

Create a new deployment freeze

PUT /api/deploymentfreezes/{id}

Path Parameters

  • id string (required)

Request Body

  • Description string
  • End string (required)
    Format date-time.
  • Id string (required)
  • Name string (required)
    Minimum length 1. Maximum length 200.
  • ProjectEnvironmentScope object
  • RecurringSchedule object
    • EndAfterOccurrences integer
    • EndDate string
      Format date-time.
    • EndOnDate string
      Format date-time.
    • EndType enum
      Allowed values: Never, OnDate, AfterOccurrences.
    • StartDate string
      Format date-time.
    • Type enum
      Allowed values: Daily, Weekly, Monthly, Annually.
    • Unit integer
    • UserUtcOffsetInMinutes integer
  • Start string (required)
    Format date-time.
  • TenantProjectEnvironmentScope array of object
    • EnvironmentId string (required)
    • ProjectId string (required)
    • TenantId string (required)

Response

200 — Modifies an existing deployment freeze

  • Description string
  • End string
    Format date-time.
  • Id string
  • Name string
    Minimum length 1.
  • ProjectEnvironmentScope object
  • RecurringSchedule object
    • EndAfterOccurrences integer
    • EndDate string
      Format date-time.
    • EndOnDate string
      Format date-time.
    • EndType enum
      Allowed values: Never, OnDate, AfterOccurrences.
    • StartDate string
      Format date-time.
    • Type enum
      Allowed values: Daily, Weekly, Monthly, Annually.
    • Unit integer
    • UserUtcOffsetInMinutes integer
  • Start string
    Format date-time.
  • TenantProjectEnvironmentScope array of object
    • EnvironmentId string
    • ProjectId string
    • TenantId string

Example Request

JSON
{
  "Description": "string",
  "End": "2020-01-01T00:00:00.000Z",
  "Id": "string",
  "Name": "string",
  "ProjectEnvironmentScope": {
    "additionalProp1": [
      "string"
    ],
    "additionalProp2": [
      "string"
    ],
    "additionalProp3": [
      "string"
    ]
  },
  "RecurringSchedule": {
    "EndAfterOccurrences": 0,
    "EndDate": "2020-01-01T00:00:00.000Z",
    "EndOnDate": "2020-01-01T00:00:00.000Z",
    "EndType": "Never",
    "StartDate": "2020-01-01T00:00:00.000Z",
    "Type": "Daily",
    "Unit": 0,
    "UserUtcOffsetInMinutes": 0
  },
  "Start": "2020-01-01T00:00:00.000Z",
  "TenantProjectEnvironmentScope": [
    {
      "EnvironmentId": "string",
      "ProjectId": "string",
      "TenantId": "string"
    }
  ]
}

Example Response

JSON
{
  "Description": "string",
  "End": "2020-01-01T00:00:00.000Z",
  "Id": "string",
  "Name": "string",
  "ProjectEnvironmentScope": {
    "additionalProp1": [
      "string"
    ],
    "additionalProp2": [
      "string"
    ],
    "additionalProp3": [
      "string"
    ]
  },
  "RecurringSchedule": {
    "EndAfterOccurrences": 0,
    "EndDate": "2020-01-01T00:00:00.000Z",
    "EndOnDate": "2020-01-01T00:00:00.000Z",
    "EndType": "Never",
    "StartDate": "2020-01-01T00:00:00.000Z",
    "Type": "Daily",
    "Unit": 0,
    "UserUtcOffsetInMinutes": 0
  },
  "Start": "2020-01-01T00:00:00.000Z",
  "TenantProjectEnvironmentScope": [
    {
      "EnvironmentId": "string",
      "ProjectId": "string",
      "TenantId": "string"
    }
  ]
}

Delete a deployment freeze

DELETE /api/deploymentfreezes/{id}

Path Parameters

  • id string (required)
    ID of the DeploymentFreeze to delete.

Response

200 — Success

Override a deployment freeze to create a deployment

POST /api/{spaceId}/deployments/override

Also reachable at /api/deployments/override, /api/spaces/{spaceIdentifier}/deployments/override.

Path Parameters

  • spaceId string (required)

Request Body

  • CreateDeploymentCommand object (required)
    • ChangeRequestSettings array of object
    • Changes array of object
    • ChangesMarkdown string
    • ChannelId string
    • Comments string
    • Created string
      Format date-time.
    • DebugMode string
    • DeployedBy string
    • DeployedById string
    • DeployedToMachineIds array of string
    • DeploymentProcessId string
    • EnvironmentId string (required)
    • ExcludedMachineIds array of string
      A collection of machines in the target environment that should be excluded from the deployment.
    • ExcludedTargetTagIds array of string
      A collection of target tag IDs that should be excluded from the deployment. Only deployment targets that have none of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.
    • ExecutionPlanLogContext object
    • FailTargetDiscovery boolean
    • FailureEncountered boolean
    • ForcePackageDownload boolean
    • ForcePackageRedeployment boolean
    • FormValues object
    • Id string
      Gets or sets a unique identifier for this resource.
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
    • ManifestVariableSetId string
    • Name string
    • Priority string
    • ProjectId string
    • QueueTime string
      If set this time will be the used to schedule the deployment to a later time, null is assumed to mean the time will be executed immediately. Format date-time.
    • QueueTimeExpiry string
      Format date-time.
    • ReleaseId string (required)
    • SkipActions array of string
    • SpaceId string
    • SpecificMachineIds array of string
      A collection of machines in the target environment that should be deployed to. If the collection is empty, all enabled machines are deployed.
    • SpecificTargetTagIds array of string
      A collection of target tag IDs that should be included in the deployment. Only deployment targets that have at least one of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.
    • TaskId string
    • TenantId string
    • TentacleRetentionPeriod object
    • UseGuidedFailure boolean
      If set to true, the deployment will prompt for manual intervention (Fail/Retry/Ignore) when failures are encountered in activities that support it. May be overridden with the Octopus.UseGuidedFailure special variable.
  • FreezeIds array of string (required)
  • Reason string (required)
    Minimum length 1.
  • SpaceId string (required)

Response

201 — Created

  • Deployment object
    • ChangeRequestSettings array of object
    • Changes array of object
    • ChangesMarkdown string
    • ChannelId string
    • Comments string
    • Created string
      Format date-time.
    • DebugMode string
    • DeployedBy string
    • DeployedById string
    • DeployedToMachineIds array of string
    • DeploymentProcessId string
    • EnvironmentId string
    • ExcludedMachineIds array of string
      A collection of machines in the target environment that should be excluded from the deployment.
    • ExcludedTargetTagIds array of string
      A collection of target tag IDs that should be excluded from the deployment. Only deployment targets that have none of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.
    • ExecutionPlanLogContext object
    • FailTargetDiscovery boolean
    • FailureEncountered boolean
    • ForcePackageDownload boolean
    • ForcePackageRedeployment boolean
    • FormValues object
    • Id string
      Gets or sets a unique identifier for this resource.
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
    • ManifestVariableSetId string
    • Name string
    • Priority string
    • ProjectId string
    • QueueTime string
      If set this time will be the used to schedule the deployment to a later time, null is assumed to mean the time will be executed immediately. Format date-time.
    • QueueTimeExpiry string
      Format date-time.
    • ReleaseId string
    • SkipActions array of string
    • SpaceId string
    • SpecificMachineIds array of string
      A collection of machines in the target environment that should be deployed to. If the collection is empty, all enabled machines are deployed.
    • SpecificTargetTagIds array of string
      A collection of target tag IDs that should be included in the deployment. Only deployment targets that have at least one of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.
    • TaskId string
    • TenantId string
    • TentacleRetentionPeriod object
    • UseGuidedFailure boolean
      If set to true, the deployment will prompt for manual intervention (Fail/Retry/Ignore) when failures are encountered in activities that support it. May be overridden with the Octopus.UseGuidedFailure special variable.

Example Request

JSON
{
  "CreateDeploymentCommand": {
    "ChangeRequestSettings": [
      {
        "Type": "ServiceNow"
      }
    ],
    "Changes": [
      {
        "BuildInformation": [
          {}
        ],
        "Commits": [
          {}
        ],
        "ReleaseNotes": "string",
        "Version": "string",
        "WorkItems": [
          {}
        ]
      }
    ],
    "ChangesMarkdown": "string",
    "ChannelId": "string",
    "Comments": "string",
    "Created": "2020-01-01T00:00:00.000Z",
    "DebugMode": "string",
    "DeployedBy": "string",
    "DeployedById": "string",
    "DeployedToMachineIds": [
      "string"
    ],
    "DeploymentProcessId": "string",
    "EnvironmentId": "string",
    "ExcludedMachineIds": [
      "string"
    ],
    "ExcludedTargetTagIds": [
      "string"
    ],
    "ExecutionPlanLogContext": {
      "Steps": [
        {}
      ]
    },
    "FailTargetDiscovery": true,
    "FailureEncountered": true,
    "ForcePackageDownload": true,
    "ForcePackageRedeployment": true,
    "FormValues": {
      "additionalProp1": "string",
      "additionalProp2": "string",
      "additionalProp3": "string"
    },
    "Id": "string",
    "LastModifiedBy": "string",
    "LastModifiedOn": "2020-01-01T00:00:00.000Z",
    "Links": {
      "additionalProp1": "string",
      "additionalProp2": "string",
      "additionalProp3": "string"
    },
    "ManifestVariableSetId": "string",
    "Name": "string",
    "Priority": "string",
    "ProjectId": "string",
    "QueueTime": "2020-01-01T00:00:00.000Z",
    "QueueTimeExpiry": "2020-01-01T00:00:00.000Z",
    "ReleaseId": "string",
    "SkipActions": [
      "string"
    ],
    "SpaceId": "string",
    "SpecificMachineIds": [
      "string"
    ],
    "SpecificTargetTagIds": [
      "string"
    ],
    "TaskId": "string",
    "TenantId": "string",
    "TentacleRetentionPeriod": {
      "QuantityToKeep": 0,
      "ShouldKeepForever": true,
      "Strategy": "string",
      "Unit": "Days"
    },
    "UseGuidedFailure": true
  },
  "FreezeIds": [
    "string"
  ],
  "Reason": "string",
  "SpaceId": "string"
}

Example Response

JSON
{
  "Deployment": {
    "ChangeRequestSettings": [
      {
        "Type": "ServiceNow"
      }
    ],
    "Changes": [
      {
        "BuildInformation": [
          {}
        ],
        "Commits": [
          {}
        ],
        "ReleaseNotes": "string",
        "Version": "string",
        "WorkItems": [
          {}
        ]
      }
    ],
    "ChangesMarkdown": "string",
    "ChannelId": "string",
    "Comments": "string",
    "Created": "2020-01-01T00:00:00.000Z",
    "DebugMode": "string",
    "DeployedBy": "string",
    "DeployedById": "string",
    "DeployedToMachineIds": [
      "string"
    ],
    "DeploymentProcessId": "string",
    "EnvironmentId": "string",
    "ExcludedMachineIds": [
      "string"
    ],
    "ExcludedTargetTagIds": [
      "string"
    ],
    "ExecutionPlanLogContext": {
      "Steps": [
        {}
      ]
    },
    "FailTargetDiscovery": true,
    "FailureEncountered": true,
    "ForcePackageDownload": true,
    "ForcePackageRedeployment": true,
    "FormValues": {
      "additionalProp1": "string",
      "additionalProp2": "string",
      "additionalProp3": "string"
    },
    "Id": "string",
    "LastModifiedBy": "string",
    "LastModifiedOn": "2020-01-01T00:00:00.000Z",
    "Links": {
      "additionalProp1": "string",
      "additionalProp2": "string",
      "additionalProp3": "string"
    },
    "ManifestVariableSetId": "string",
    "Name": "string",
    "Priority": "string",
    "ProjectId": "string",
    "QueueTime": "2020-01-01T00:00:00.000Z",
    "QueueTimeExpiry": "2020-01-01T00:00:00.000Z",
    "ReleaseId": "string",
    "SkipActions": [
      "string"
    ],
    "SpaceId": "string",
    "SpecificMachineIds": [
      "string"
    ],
    "SpecificTargetTagIds": [
      "string"
    ],
    "TaskId": "string",
    "TenantId": "string",
    "TentacleRetentionPeriod": {
      "QuantityToKeep": 0,
      "ShouldKeepForever": true,
      "Strategy": "string",
      "Unit": "Days"
    },
    "UseGuidedFailure": true
  }
}